=== debian/changelog ===
rust-capstone-sys (0.17.0-3) unstable; urgency=medium

  * Team upload.
  * Package capstone-sys 0.17.0 from crates.io using debcargo 2.7.8
  * Relax dependency on bindgen

 -- NoisyCoil <noisycoil@debian.org>  Fri, 05 Sep 2025 20:26:33 +0200

rust-capstone-sys (0.17.0-2) unstable; urgency=medium

  * Package capstone-sys 0.17.0 from crates.io using debcargo 2.7.7+alpha.0

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 15 Feb 2025 16:25:58 +0100

rust-capstone-sys (0.17.0-1) experimental; urgency=medium

  * Team upload.
  * Package capstone-sys 0.17.0 from crates.io using debcargo 2.7.6
  * d/rules: remove the overlay (don't delete SelectionDAGCompat.td
    in the clean target)
  * d/patches: refresh
  * d/copyright: refresh copyright years

 -- NoisyCoil <noisycoil@tutanota.com>  Sun, 09 Feb 2025 13:43:34 +0100

rust-capstone-sys (0.15.0-4) unstable; urgency=medium

  * Team upload.
  * Package capstone-sys 0.15.0 from crates.io using debcargo 2.7.6
  * d/patches: rename relax-dep.diff as relax-bindgen.patch (bump bindgen
    dependency to v0.71)

 -- NoisyCoil <noisycoil@tutanota.com>  Thu, 30 Jan 2025 15:49:10 +0100

rust-capstone-sys (0.15.0-3) unstable; urgency=medium

  * Team upload.
  * Package capstone-sys 0.15.0 from crates.io using debcargo 2.7.2
  * Bump bindgen dependency to v0.70

 -- NoisyCoil <noisycoil@tutanota.com>  Thu, 21 Nov 2024 19:56:40 +0000

rust-capstone-sys (0.15.0-2) unstable; urgency=medium

  * Package capstone-sys 0.15.0 from crates.io using debcargo 2.6.0

  [ Matthias Geiger ]
  * Team upload.
  * Package capstone-sys 0.15.0 from crates.io using debcargo 2.6.0
  * Updated patch for newer bindgen.

 -- Peter Michael Green <plugwash@debian.org>  Tue, 19 Sep 2023 23:28:17 +0000
