=== debian/control ===
Source: rust-capstone-sys
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-cargo
Build-Depends-Arch: cargo:native <!nocheck>,
 rustc:native (>= 1.70) <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-cc-1+default-dev <!nocheck>,
 librust-libc-0.2-dev (>= 0.2.59-~~) <!nocheck>
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Michael R. Crusoe <crusoe@debian.org>
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/capstone-sys]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/capstone-sys
Homepage: https://github.com/capstone-rust/capstone-rs/tree/master/capstone-sys
X-Cargo-Crate: capstone-sys
Rules-Requires-Root: no

Package: librust-capstone-sys-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-bindgen-0+default-dev (>= 0.71-~~),
 librust-cc-1+default-dev,
 librust-libc-0.2-dev (>= 0.2.59-~~),
 librust-regex-1+default-dev (>= 1.10.4-~~)
Provides:
 librust-capstone-sys+bindgen-dev (= ${binary:Version}),
 librust-capstone-sys+default-dev (= ${binary:Version}),
 librust-capstone-sys+full-dev (= ${binary:Version}),
 librust-capstone-sys+regex-dev (= ${binary:Version}),
 librust-capstone-sys+use-bindgen-dev (= ${binary:Version}),
 librust-capstone-sys-0-dev (= ${binary:Version}),
 librust-capstone-sys-0+bindgen-dev (= ${binary:Version}),
 librust-capstone-sys-0+default-dev (= ${binary:Version}),
 librust-capstone-sys-0+full-dev (= ${binary:Version}),
 librust-capstone-sys-0+regex-dev (= ${binary:Version}),
 librust-capstone-sys-0+use-bindgen-dev (= ${binary:Version}),
 librust-capstone-sys-0.17-dev (= ${binary:Version}),
 librust-capstone-sys-0.17+bindgen-dev (= ${binary:Version}),
 librust-capstone-sys-0.17+default-dev (= ${binary:Version}),
 librust-capstone-sys-0.17+full-dev (= ${binary:Version}),
 librust-capstone-sys-0.17+regex-dev (= ${binary:Version}),
 librust-capstone-sys-0.17+use-bindgen-dev (= ${binary:Version}),
 librust-capstone-sys-0.17.0-dev (= ${binary:Version}),
 librust-capstone-sys-0.17.0+bindgen-dev (= ${binary:Version}),
 librust-capstone-sys-0.17.0+default-dev (= ${binary:Version}),
 librust-capstone-sys-0.17.0+full-dev (= ${binary:Version}),
 librust-capstone-sys-0.17.0+regex-dev (= ${binary:Version}),
 librust-capstone-sys-0.17.0+use-bindgen-dev (= ${binary:Version})
Description: System bindings to the capstone disassembly library - Rust source code
 Source code for Debianized Rust crate "capstone-sys"
